Subject: BooleanConverter considers "false" TRUE
Description

The BooleanConverter provided by Flow simply casts the $source to a boolean using boxing:

1return (boolean)$source;

This leads to some weird inconsistencies, e.g. the string "false" returning TRUE.

Related issues:
related to TYPO3.Flow - Bug # 59023: BooleanConverter should not convert empt... New 2014-05-22
duplicated by TYPO3.Flow - Bug # 51255: CommandController: Fix parsing of boo... Resolved 2013-08-22

Associated revisions
Revision 8207a130 - 2013-08-27 14:08 - Bastian Waidelich

[BUGFIX] BooleanConverter considers "false" TRUE

The BooleanConverter provided by Flow simply casts the $source
to a boolean using boxing.
With this change a string "false" (case insensitive) is considered FALSE.

Change-Id: I95ba005490fb158a17b6b7fe3dc1787d96939299
Releases: master, 2.0
Fixes: #51255
Fixes: #51385

Revision 90d745a0 - 2014-01-31 16:02 - Bastian Waidelich

[BUGFIX] BooleanConverter considers "false" TRUE

The BooleanConverter provided by Flow simply casts the $source
to a boolean using boxing.
With this change a string "false" (case insensitive) is considered FALSE.

Change-Id: I95ba005490fb158a17b6b7fe3dc1787d96939299
Releases: master, 2.0
Fixes: #51255
Fixes: #51385

History
#1 - 2013-08-27 12:40 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/23355

#2 - 2013-08-27 13:32 - Timo Dödtmann

The documentation (http://docs.typo3.org/flow/TYPO3FlowDocumentation/TheDefinitiveGuide/PartIII/CommandLine.html#passing-arguments) says
following:
  Possible values equivalent to TRUE are: on, 1, y, yes, true. Possible values equivalent to FALSE are: off, 0, n, no, false.
So, it must be something like that:
    -  check (exactly) possible TRUE values (so, you can see FALSE as a fallback) 

if (is_bool($source)) {
    return $source;
}
return (!empty($source) && in_array(strtolower($source), array('on', '1', 'y', 'yes', 'true')));

    -  check (exactly) possible FALSE values (so, you can see TRUE as a fallback) 

if (is_bool($source)) {
    return $source;
}
return (!empty($source) && !in_array(strtolower($source), array('off', '0', 'n', 'no', 'false')));

#3 - 2013-08-27 14:08 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/23355

#4 - 2013-08-27 14:09 - Bastian Waidelich

Timo Dödtmann wrote:

The documentation (http://docs.typo3.org/flow/TYPO3FlowDocumentation/TheDefinitiveGuide/PartIII/CommandLine.html#passing-arguments)
says following:
Possible values equivalent to TRUE are: on, 1, y, yes, true. Possible values equivalent to FALSE are: off, 0, n, no, false.

good point. See PS#2 at https://review.typo3.org/23355 and feel free to test/vote for the patch
#5 - 2013-10-08 14:37 - Bastian Waidelich
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

#6 - 2014-01-31 16:02 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch 2.0 of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/27205

#7 - 2014-05-11 12:54 - Bastian Waidelich
- Status changed from Under Review to Resolved
